#include <winsock.h>
#include <stdio.h>

class Comm {

public:

	Comm();
	~Comm();
	
	virtual void openConn();
	virtual void openServerConn();

	virtual void closeConn();
	virtual void sendData(char *);
	virtual void recvData(char *);
	 
	virtual void setPort(int);

	virtual void setMaxMsgLength(int);

	virtual char* getAddr();
	virtual bool isConnected() {return connected;}

	virtual void setIP(char*);
	virtual char *getIP();

	virtual void setAddr(char*);

protected:

	WSADATA ws;
	SOCKET sckt;
	sockaddr_in san;

	char *IP;

	int MSG_LENGTH;
	int PORT;
	int sanSize;
	bool connected; //connected boolean so I can see if they are connected or not

};