#include "cWindow.h"

bool cWindow::Create(char *imgPath) {

	Destroy();
	picBMP = (HBITMAP)LoadImage(NULL,imgPath,IMAGE_BITMAP,0,0,LR_LOADFROMFILE | LR_CREATEDIBSECTION);
	
	if (!picBMP) {picLoaded = false;return false;}

	pic = CreatePatternBrush(picBMP);
	
	winclass.cbSize = sizeof(WNDCLASSEX);
	winclass.style = CS_DBLCLKS | CS_OWNDC | CS_HREDRAW | CS_VREDRAW;
	winclass.lpfnWndProc = WindowProc2;
	winclass.cbClsExtra = 0;
	winclass.cbWndExtra = 0;
	winclass.hInstance = hinstance;
	winclass.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	winclass.hCursor = LoadCursor(NULL, IDC_ARROW);
	winclass.hbrBackground = (HBRUSH)pic;//GetStockObject(BLACK_BRUSH);
	winclass.lpszMenuName = NULL;
	winclass.lpszClassName = " ";
	winclass.hIconSm = LoadIcon(NULL, IDI_APPLICATION);

	
	if (!RegisterClassEx(&winclass)) {
		picLoaded = false;
		return false;
	}

	if (!(theWindow = CreateWindowEx(NULL," "," ",WS_OVERLAPPEDWINDOW | SW_HIDE
											,0,0,640,480,NULL,NULL,hinstance,NULL))) {
		picLoaded = false;
		return false;
	}
	
	picLoaded = true;
	return true;
}

void cWindow::Destroy() {

	DestroyWindow(theWindow);
	UnregisterClass(" ",hinstance);
}

void cWindow::Show(bool show) {
	if (show) {
	//	SetForegroundWindow(theWindow);
	//	SetActiveWindow(theWindow);
		ShowWindow(theWindow,SW_SHOWMAXIMIZED);
	}
	else if (!show) {
		ShowWindow(theWindow,SW_HIDE);
	}
}

LRESULT CALLBACK WindowProc2(HWND hwnd, UINT msg, 
                            WPARAM wparam,LPARAM lParam) {

	return (DefWindowProc(hwnd, msg, wparam, lParam));

};